export interface MemoizerOptions {
    cacheId: string;
    cachePath: string;
    salt: string;
    maxAge: number;
    force: boolean;
    astBody: boolean;
    noBody: boolean;
    throwError: boolean;
    retryOnInvalidCache: boolean;
    serialize: (val: unknown) => string;
    deserialize: (val: string) => unknown;
}
export declare function getCacheFilePath(fn: unknown, args: unknown[], opt: Partial<MemoizerOptions>): string;
export default function buildMemoizer(memoizerOptions: Partial<MemoizerOptions>): {
    fn: <FN extends (...args: never) => unknown>(fn: FN, opt?: Partial<MemoizerOptions>) => Promise<(...args: Parameters<FN>) => EnsurePromise<ReturnType<FN>>>;
    getCacheFilePath: (fn: (...args: never) => unknown, args: unknown[], opt: Partial<MemoizerOptions>) => string;
    invalidate: (cacheId?: string) => Promise<void>;
};
type EnsurePromise<T> = T extends PromiseLike<unknown> ? T : Promise<T>;
export {};
